#pragma once

#include <string>
using namespace std;

typedef int Timespan;

class Time
{
private:
	int seconds;	// Seconds since midnight

public:
	Time(int h = 0, int m = 0, int s = 0);

	// Relational operators.
	bool operator == (const Time & rhs) const;
	bool operator != (const Time & rhs) const;
	bool operator >  (const Time & rhs) const;
	bool operator >= (const Time & rhs) const;
	bool operator <  (const Time & rhs) const;
	bool operator <= (const Time & rhs) const;

	// Mathematical operators.
	Time operator + (const Timespan & amount) const;
	Time operator - (const Timespan & amount) const;
	Timespan operator - (const Time & rhs) const;
	Time& operator += (const Timespan & amount);
	Time& operator -= (const Timespan & amount);
	Time& operator ++ ();
	Time  operator ++ (int);
	Time& operator -- ();
	Time  operator -- (int);

	// Unary negation operator.
	bool operator ! () const;

	// Additional methods.
	void Set(int h, int m, int s);
	int GetHour() const;
	int GetMinute() const;
	int GetSecond() const;
	string ToString() const;
};

// Stream operators.
ostream & operator << (ostream & os, const Time & t);
istream & operator >> (istream & is, Time & t);
